package com.cf.imes.module.manage.controller.admin.plate;

import com.cf.imes.module.manage.controller.admin.plate.vo.remain.RemainPlatePageReqVO;
import com.cf.imes.module.manage.controller.admin.plate.vo.remain.RemainPlateRespVO;
import com.cf.imes.module.manage.controller.admin.plate.vo.remain.RemainPlateSaveReqVO;
import com.cf.imes.module.manage.controller.admin.plate.vo.remain.RemainPlateUptReqVO;
import com.cf.imes.module.manage.dal.dataobject.remainplaten.RemainPlateDO;
import com.cf.imes.module.manage.service.remainplaten.RemainPlateService;
import io.swagger.v3.oas.annotations.Parameters;
import org.springframework.web.bind.annotation.*;
import org.springframework.validation.annotation.Validated;
import org.springframework.security.access.prepost.PreAuthorize;
import io.swagger.v3.oas.annotations.tags.Tag;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.Operation;

import java.util.*;
import java.io.IOException;

import com.cf.imes.framework.common.pojo.PageParam;
import com.cf.imes.framework.common.pojo.PageResult;
import com.cf.imes.framework.common.pojo.CommonResult;
import com.cf.imes.framework.common.util.object.BeanUtils;
import static com.cf.imes.framework.common.pojo.CommonResult.success;

import com.cf.imes.framework.excel.core.util.ExcelUtils;

import com.cf.imes.framework.operatelog.core.annotations.OperateLog;
import static com.cf.imes.framework.operatelog.core.enums.OperateTypeEnum.*;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletResponse;
import javax.validation.Valid;

@Tag(name = "管理后台 - 生产单余料板表")
@RestController
@RequestMapping("/manage/remain-plate")
@Validated
public class RemainPlateController {

    @Resource
    private RemainPlateService remainPlateService;

    @PostMapping("/create")
    @Operation(summary = "创建生产单余料板表(单个)")
    @PreAuthorize("@ss.hasPermission('manage:remain-plate:create')")
    public CommonResult<Long> createRemainPlate(@Valid @RequestBody RemainPlateSaveReqVO createReqVO) {
        return success(remainPlateService.createRemainPlate(createReqVO));
    }

    @PostMapping("/createMultiple")
    @Operation(summary = "创建生产单余料板表(多个)")
    @PreAuthorize("@ss.hasPermission('manage:remain-plate:create')")
    public CommonResult<Boolean> createRemainPlateMultiple(@Valid @RequestBody Set<RemainPlateSaveReqVO> createReqVOS) {
        return success(remainPlateService.createRemainPlateMultiple(createReqVOS));
    }

    @PutMapping("/update")
    @Operation(summary = "更新生产单余料板表")
    @PreAuthorize("@ss.hasPermission('manage:remain-plate:update')")
    public CommonResult<Boolean> updateRemainPlate(@Valid @RequestBody RemainPlateSaveReqVO updateReqVO) {
        remainPlateService.updateRemainPlate(updateReqVO);
        return success(true);
    }

    @PutMapping("/updateStatus")
    @Operation(summary = "余料板批量核销")
    @PreAuthorize("@ss.hasPermission('manage:remain-plate:update')")
    public CommonResult<Boolean> updateRemainPlate(@RequestBody RemainPlateUptReqVO updateReqVO) {
        remainPlateService.updateRemainPlateStatus(updateReqVO.getIds(),
                updateReqVO.getStatus(),
                updateReqVO.getUseType(),
                updateReqVO.getPlanId());
        return success(true);
    }

    @PutMapping("/revertUpdate")
    @Operation(summary = "余料板批量释放")
    @PreAuthorize("@ss.hasPermission('manage:remain-plate:update')")
    public CommonResult<Boolean> revertRemainPlate(@RequestBody RemainPlateUptReqVO updateReqVO) {
        remainPlateService.revertRemainPlateStatus(updateReqVO.getIds(),updateReqVO.getStatus());
        return success(true);
    }

    @DeleteMapping("/delete")
    @Operation(summary = "删除生产单余料板表")
    @Parameter(name = "id", description = "编号", required = true)
    @PreAuthorize("@ss.hasPermission('manage:remain-plate:delete')")
    public CommonResult<Boolean> deleteRemainPlate(@RequestParam("id") Set<Long> ids) {
        remainPlateService.deleteRemainPlate(ids);
        return success(true);
    }

    @GetMapping("/get")
    @Operation(summary = "获得生产单余料板表")
    @Parameter(name = "id", description = "编号", required = true, example = "1024")
    @PreAuthorize("@ss.hasPermission('manage:remain-plate:query')")
    public CommonResult<RemainPlateRespVO> getRemainPlate(@RequestParam("id") Long id) {
        RemainPlateDO remainPlate = remainPlateService.getRemainPlate(id);
        return success(BeanUtils.toBean(remainPlate, RemainPlateRespVO.class));
    }

    @GetMapping("/page")
    @Operation(summary = "获得生产单余料板表分页")
    @PreAuthorize("@ss.hasPermission('manage:remain-plate:query')")
    public CommonResult<PageResult<RemainPlateRespVO>> getRemainPlatePage(@Valid RemainPlatePageReqVO pageReqVO) {
        PageResult<RemainPlateDO> pageResult = remainPlateService.getRemainPlatePage(pageReqVO);
        return success(BeanUtils.toBean(pageResult, RemainPlateRespVO.class));
    }

    @GetMapping("/export-excel")
    @Operation(summary = "导出生产单余料板表Excel")
    @PreAuthorize("@ss.hasPermission('manage:remain-plate:export')")
    @OperateLog(type = EXPORT)
    public void exportRemainPlateExcel(@Valid RemainPlatePageReqVO pageReqVO,
                                       HttpServletResponse response) throws IOException {
        pageReqVO.setPageSize(PageParam.PAGE_SIZE_NONE);
        List<RemainPlateDO> list = remainPlateService.getRemainPlatePage(pageReqVO).getList();
        // 导出 Excel
        ExcelUtils.write(response, "生产单余料板表 order_remain_plate_{N}.xls", "数据", RemainPlateRespVO.class,
                BeanUtils.toBean(list, RemainPlateRespVO.class));
    }

}